using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using System.Reflection;

// See: https://social.msdn.microsoft.com/Forums/en-US/576f69e7-55aa-4574-8d31-417422954689/get-a-list-of-delegate-on-event

namespace howto_remove_event_handlers
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private bool MouseIsDown = false;

        private void btnAdd_Click(object sender, EventArgs e)
        {
            btnClickMe.Click += btnClickMe_Click;
            picCanvas.Click += picCanvas_Click;
            picCanvas.MouseClick += picCanvas_MouseClick;
            picCanvas.MouseDown += picCanvas_MouseDown;
            picCanvas.MouseMove += picCanvas_MouseMove;
            picCanvas.MouseUp += picCanvas_MouseUp;
            txtOutput.AppendText("Added event handlers\r\n");
        }

        private void btnRemove_Click(object sender, EventArgs e)
        {
            RemoveEvent(btnClickMe, "EventClick");
            RemoveEvent(picCanvas, "EventClick");
            RemoveEvent(picCanvas, "EventMouseClick");
            RemoveEvent(picCanvas, "EventMouseDown");
            RemoveEvent(picCanvas, "EventMouseMove");
            RemoveEvent(picCanvas, "EventMouseUp");
            MouseIsDown = false;
            txtOutput.AppendText("Removed event handlers\r\n");
        }

        // Remove all event handlers from the control's named event.
        private void RemoveEvent(Control ctl, string event_name)
        {
            FieldInfo field_info = typeof(Control).GetField(event_name,
                BindingFlags.Static | BindingFlags.NonPublic);

            PropertyInfo property_info = ctl.GetType().GetProperty("Events",
                BindingFlags.NonPublic | BindingFlags.Instance);

            object obj = field_info.GetValue(ctl);
            EventHandlerList event_handlers =
                (EventHandlerList)property_info.GetValue(ctl, null);
            event_handlers.RemoveHandler(obj, event_handlers[obj]);
        }

        private void picCanvas_Click(object sender, EventArgs e)
        {
            txtOutput.AppendText("picCanvas_Click\r\n");
        }

        private void btnClickMe_Click(object sender, EventArgs e)
        {
            txtOutput.AppendText("btnClickMe_Click\r\n");
        }

        private void picCanvas_MouseClick(object sender, MouseEventArgs e)
        {
            txtOutput.AppendText("picCanvas_MouseClick\r\n");
        }

        private void picCanvas_MouseDown(object sender, MouseEventArgs e)
        {
            MouseIsDown = true;
            txtOutput.AppendText("picCanvas_MouseDown\r\n");
        }

        private void picCanvas_MouseMove(object sender, MouseEventArgs e)
        {
            if (!MouseIsDown) return;
            txtOutput.AppendText("picCanvas_MouseMove\r\n");
        }

        private void picCanvas_MouseUp(object sender, MouseEventArgs e)
        {
            MouseIsDown = false;
            txtOutput.AppendText("picCanvas_MouseUp\r\n");
        }
    }
}
